/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: formula.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2006/08/14 13:35:02 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef SC_FORMULA_HXX
#define SC_FORMULA_HXX

#ifndef SC_ANYREFDG_HXX
#include "anyrefdg.hxx"
#endif

#ifndef SC_SCGLOB_HXX
#include "global.hxx"		// ScAddress
#endif

#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif

#ifndef _SVSTDARR_STRINGS

#define _SVSTDARR_STRINGS
#include <svtools/svstdarr.hxx>

#endif

#ifndef _SV_TABCTRL_HXX //autogen
#include <vcl/tabctrl.hxx>
#endif

#ifndef SC_PARAWIN_HXX
#include "parawin.hxx"
#endif

#ifndef _SVTREEBOX_HXX //autogen
#include <svtools/svtreebx.hxx>
#endif

#ifndef SC_COMPILER_HXX
#include "compiler.hxx"
#endif

#ifndef SC_CELL_HXX
#include "cell.hxx"
#endif

#ifndef SC_FUNCPAGE_HXX
#include "funcpage.hxx"
#endif

#ifndef SC_STRUCTPG_HXX
#include "structpg.hxx"
#endif
namespace binfilter {

//STRIP001 class ScViewData;
//STRIP001 class ScDocument;
//STRIP001 class ScFuncDesc;
//STRIP001 class ScInputHandler;
//STRIP001 class ScDocShell;

//============================================================================

enum ScFormulaDlgMode { SC_FORMDLG_FORMULA, SC_FORMDLG_ARGS, SC_FORMDLG_EDIT };

//============================================================================

typedef ScTabViewShell* PtrTabViewShell;

//============================================================================

//============================================================================

//STRIP001 class ScFormulaDlg : public ScAnyRefDlg
//STRIP001 {
//STRIP001 public:
//STRIP001 					ScFormulaDlg( SfxBindings* pB, SfxChildWindow* pCW,
//STRIP001 									Window* pParent, ScViewData* pViewData );
//STRIP001 					~ScFormulaDlg();
//STRIP001 
//STRIP001 	virtual void	SetReference( const ScRange& rRef, ScDocument* pRefDoc );
//STRIP001 	virtual BOOL	IsRefInputMode() const;
//STRIP001 	virtual BOOL	IsDocAllowed(SfxObjectShell* pDocSh) const;
//STRIP001 	virtual void	SetActive();
//STRIP001 	virtual BOOL	Close();
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001 	TabControl		aTabCtrl;
//STRIP001 	GroupBox		aGbEdit;		//! MUST be placed before aScParaWin for initializing
//STRIP001 	ScParaWin		aScParaWin;
//STRIP001 	FixedText		aFtHeadLine;
//STRIP001 	FixedInfo		aFtFuncName;
//STRIP001 	FixedInfo		aFtFuncDesc;
//STRIP001 
//STRIP001 	FixedText		aFtEditName;
//STRIP001 	//FixedInfo		aFtEditDesc;
//STRIP001 
//STRIP001 	FixedText		aFtResult;
//STRIP001 	ValWnd			aWndResult;
//STRIP001 
//STRIP001 	FixedText		aFtFormula;
//STRIP001 	ScEditBox		aMEFormula;
//STRIP001 
//STRIP001 	CheckBox		aBtnMatrix;
//STRIP001 	HelpButton		aBtnHelp;
//STRIP001 	CancelButton	aBtnCancel;
//STRIP001 
//STRIP001 	PushButton		aBtnBackward;
//STRIP001 	PushButton		aBtnForward;
//STRIP001 	OKButton		aBtnEnd;
//STRIP001 
//STRIP001 	ScRefEdit		aEdRef;
//STRIP001 	ScRefButton		aRefBtn;
//STRIP001 
//STRIP001 	FixedText		aFtFormResult;
//STRIP001 	ValWnd			aWndFormResult;
//STRIP001 
//STRIP001 	ScRefEdit*		pTheRefEdit;
//STRIP001 	ScRefButton*	pTheRefButton;
//STRIP001 	ScFuncPage*		pScFuncPage;
//STRIP001 	ScStructPage*	pScStructPage;
//STRIP001 	ScFormulaCell*	pCell;
//STRIP001 	ScCompiler*		pComp;
//STRIP001 	ScTokenArray*	pScTokA;
//STRIP001 	String			aOldFormula;
//STRIP001 	BOOL			bStructUpdate;
//STRIP001 	MultiLineEdit*  pMEdit;
//STRIP001 	BOOL			bUserMatrixFlag;
//STRIP001 	Timer			aTimer;
//STRIP001 
//STRIP001 	const String	aTitle1;
//STRIP001 	const String	aTitle2;
//STRIP001 	const String	aTxtEnd;
//STRIP001 	const String	aTxtOk;		// hinter aBtnEnd
//STRIP001 
//STRIP001 	ULONG			nOldHelp;
//STRIP001 	ULONG			nOldUnique;
//STRIP001 	ULONG			nActivWinId;
//STRIP001 	BOOL			bIsShutDown;
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 	Font			aFntBold;
//STRIP001 	Font			aFntLight;
//STRIP001 	USHORT			nEdFocus;
//STRIP001 //    Selection       theCurSel;
//STRIP001 	BOOL			bEditFlag;
//STRIP001 	ScFuncDesc*		pFuncDesc;
//STRIP001 	USHORT			nArgs;
//STRIP001 	String**		pArgArr;
//STRIP001 	Selection		aFuncSel;
//STRIP001 
//STRIP001 	static ScDocument*	pDoc;
//STRIP001 	static ScAddress	aCursorPos;
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 	virtual void	RefInputStart( ScRefEdit* pEdit, ScRefButton* pButton = NULL );
//STRIP001 	virtual void	RefInputDone( BOOL bForced = FALSE );
//STRIP001 	ULONG			FindFocusWin(Window *pWin);
//STRIP001 	void			SetFocusWin(Window *pWin,ULONG nUniqueId);
//STRIP001 	String			RepairFormula(const String& aFormula);
//STRIP001 	void			SaveLRUEntry(ScFuncDesc*	pFuncDesc);
//STRIP001 	void			HighlightFunctionParas(const String& aFormula);
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001 	BOOL			IsInputHdl(ScInputHandler* pHdl);
//STRIP001 	ScInputHandler* GetNextInputHandler(ScDocShell* pDocShell,PtrTabViewShell* ppViewSh=NULL);
//STRIP001 
//STRIP001 	void			MakeTree(SvLBoxEntry* pParent,ScToken* pScToken,long Count,
//STRIP001 									ScTokenArray* pScTokA,ScCompiler*	pComp);
//STRIP001 
//STRIP001 	void			ClearAllParas();
//STRIP001 	void			DeleteArgs();
//STRIP001 	void			FillDialog(BOOL nFlag=TRUE);
//STRIP001 	void			EditNextFunc( BOOL bForward, xub_StrLen nFStart=NOT_FOUND );
//STRIP001 	void			EditThisFunc(xub_StrLen nFStart);
//STRIP001 	void			EditFuncParas(xub_StrLen nEditPos);
//STRIP001 
//STRIP001 
//STRIP001 	void			UpdateArgInput( USHORT nOffset, USHORT nInput );
//STRIP001 	BOOL			CalcValue( const String& rStrExp, String& rStrResult );
//STRIP001 	BOOL			CalcStruct( const String& rStrExp);
//STRIP001 
//STRIP001 	void			UpdateValues();
//STRIP001 	void			SaveArg( USHORT nEd );
//STRIP001 	void			UpdateSelection();
//STRIP001 	void			DoEnter( BOOL bOk );
//STRIP001 	void			UpdateFunctionDesc();
//STRIP001 	void			ResizeArgArr( ScFuncDesc* pNewFunc );
//STRIP001 	void			FillListboxes();
//STRIP001 	void			FillControls();
//STRIP001 
//STRIP001 	xub_StrLen		GetFunctionPos(xub_StrLen nPos);
//STRIP001 	void			UpdateTokenArray( const String& rStrExp);
//STRIP001 
//STRIP001     ScRefEdit*      GetCurrRefEdit();
//STRIP001 
//STRIP001 	DECL_LINK( ScrollHdl, ScParaWin* );
//STRIP001 	DECL_LINK( ModifyHdl, ScParaWin* );
//STRIP001 	DECL_LINK( FxHdl, ScParaWin* );
//STRIP001 
//STRIP001 	DECL_LINK( MatrixHdl, CheckBox *);
//STRIP001 	DECL_LINK( FormulaHdl, MultiLineEdit* );
//STRIP001 	DECL_LINK( FormulaCursorHdl, ScEditBox*);
//STRIP001 	DECL_LINK( BtnHdl, PushButton* );
//STRIP001 	DECL_LINK( GetEdFocusHdl, ArgInput* );
//STRIP001 	DECL_LINK( GetFxFocusHdl, ArgInput* );
//STRIP001 	DECL_LINK( DblClkHdl, ScFuncPage* );
//STRIP001 	DECL_LINK( FuncSelHdl, ScFuncPage*);
//STRIP001 	DECL_LINK( StructSelHdl, ScStructPage * );
//STRIP001 	DECL_LINK( UpdateFocusHdl, Timer*);
//STRIP001 };



} //namespace binfilter
#endif // SC_CRNRDLG_HXX

