/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_prvwshll.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 01:42:49 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// auto strip #ifndef _SFXDISPATCH_HXX
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _DRAWDOC_HXX
// auto strip #include <drawdoc.hxx>
// auto strip #endif

#include <svtools/moduleoptions.hxx>
#include <bf_svx/svxids.hrc>
#include <bf_sfx2/app.hxx>
// auto strip #include "sdwindow.hxx"
// auto strip #include "sdview.hxx"
#include "sdresid.hxx"
#include "grdocsh.hxx"
// auto strip #include "docshell.hxx"
#include "prvwshll.hxx"
#include "app.hrc"
#include "strings.hrc"
#include "glob.hrc"

namespace binfilter {
#define SdPreviewViewShell
#include "sdslots.hxx"

// -------------------
// - SdPreviewViewShell -
// -------------------

/*N*/ SFX_IMPL_INTERFACE( SdPreviewViewShell, SdDrawViewShell, SdResId( STR_PREVIEWVIEWSHELL ) )
/*N*/ {
/*N*/ }

// -----------------------------------------------------------------------------

/*N*/ SFX_IMPL_VIEWFACTORY( SdPreviewViewShell, SdResId( STR_DEFAULTVIEW ) )
/*N*/ {
/*N*/     // #94383# Guard against missing modules
/*N*/ 	if (SvtModuleOptions().IsImpress())
/*N*/ 	{
/*N*/         SFX_VIEW_REGISTRATION( SdDrawDocShell );
/*N*/     }
/*N*/ 
/*N*/     // #94383# Guard against missing modules
/*N*/ 	if (SvtModuleOptions().IsDraw()) 
/*N*/     {
/*N*/         SFX_VIEW_REGISTRATION( SdGraphicDocShell );
/*N*/     }
/*N*/ }

// -----------------------------------------------------------------------------

/*N*/ TYPEINIT1( SdPreviewViewShell, SdDrawViewShell );

// -----------------------------------------------------------------------------

//STRIP001 SdPreviewViewShell::SdPreviewViewShell( SfxViewFrame* pFrame, SfxViewShell *pOldShell ) :
//STRIP001     SdDrawViewShell( pFrame, pOldShell )
//STRIP001 {
//STRIP001 	// disable scrollbars etc.
//STRIP001 	ShowUIControls( sal_False );
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 SdPreviewViewShell::SdPreviewViewShell( SfxViewFrame* pFrame, const SdDrawViewShell& rShell ) :
//STRIP001     SdDrawViewShell( pFrame, rShell )
//STRIP001 {
//STRIP001 	// disable scrollbars etc.
//STRIP001 	ShowUIControls( sal_False );
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 SdPreviewViewShell::~SdPreviewViewShell()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPreviewViewShell::OuterResizePixel(const Point &rPos, const Size &rSize)
//STRIP001 {
//STRIP001 	// override parent class, forward to AdjustPosSizePixel()
//STRIP001  	AdjustPosSizePixel(rPos, rSize);
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPreviewViewShell::InnerResizePixel(	const Point&	rPos, 
//STRIP001 											const Size&		rSize	)
//STRIP001 {
//STRIP001 	// override parent class, forward to AdjustPosSizePixel()
//STRIP001  	AdjustPosSizePixel(rPos, rSize);
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPreviewViewShell::AdjustPosSizePixel( const Point&	rNewPos,
//STRIP001 											 const Size&	rNewSize	)
//STRIP001 {
//STRIP001 	// precondition: there's only *one* view window
//STRIP001 #ifdef DBG_UTIL
//STRIP001 	for (short nX = 1; nX < MAX_HSPLIT_CNT; nX++)
//STRIP001 	{
//STRIP001 		for (short nY = 0; nY < MAX_VSPLIT_CNT; nY++)
//STRIP001 		{
//STRIP001 			DBG_ASSERT(pWinArray[nX][nY]==NULL, "Can't handle splitted view!");
//STRIP001 		}
//STRIP001 	}
//STRIP001 #endif
//STRIP001 
//STRIP001 	// prevent border
//STRIP001  	SvBorder aSvBorder;
//STRIP001  	SetBorderPixel(aSvBorder);
//STRIP001 
//STRIP001 	pWindow->UpdateMapOrigin();
//STRIP001 
//STRIP001 	// re-zoom to full page
//STRIP001 	SfxRequest aReq(SID_SIZE_PAGE, 0, pDoc->GetItemPool());
//STRIP001 	ExecuteSlot( aReq );
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 BOOL SdPreviewViewShell::KeyInput(const KeyEvent& rKEvt, SdWindow* pWin)
//STRIP001 {
//STRIP001 	// disable user interaction
//STRIP001 	return FALSE;
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPreviewViewShell::MouseMove(const MouseEvent& rMEvt, SdWindow* pWin)
//STRIP001 {
//STRIP001 	// disable user interaction
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPreviewViewShell::MouseButtonUp(const MouseEvent& rMEvt, SdWindow* pWin)
//STRIP001 {
//STRIP001 	// disable user interaction
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPreviewViewShell::MouseButtonDown(const MouseEvent& rMEvt, SdWindow* pWin)
//STRIP001 {
//STRIP001 	// disable user interaction
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 SvxRuler* SdPreviewViewShell::CreateHRuler(SdWindow* pWin, BOOL bIsFirst)
//STRIP001 {
//STRIP001 	return NULL;
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 SvxRuler* SdPreviewViewShell::CreateVRuler(SdWindow* pWin)
//STRIP001 {
//STRIP001 	return NULL;
//STRIP001 }
}
