/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sfx2_shutdownicon.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 02:30:06 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#include <shutdownicon.hxx>
#include <app.hrc>
#include <app.hxx>
#include <vos/mutex.hxx>
#include <svtools/imagemgr.hxx>
// #include <cmdlineargs.hxx>

#ifndef _COM_SUN_STAR_TASK_XINTERACTIONHANDLER_HPP_
#include <com/sun/star/task/XInteractionHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHRESULTLISTENER_HPP_
#include <com/sun/star/frame/XDispatchResultListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XNOTIFYINGDISPATCH_HPP_
#include <com/sun/star/frame/XNotifyingDispatch.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMESSUPPLIER_HPP_
#include <com/sun/star/frame/XFramesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCOMPONENTLOADER_HPP_
#include <com/sun/star/frame/XComponentLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMESSUPPLIER_HPP_
#include <com/sun/star/frame/XFramesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_UI_DIALOGS_XFILEPICKERCONTROLACCESS_HPP_
#include <com/sun/star/ui/dialogs/XFilePickerControlAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_UI_DIALOGS_XFILTERMANAGER_HPP_
#include <com/sun/star/ui/dialogs/XFilterManager.hpp>
#endif
#ifndef _COM_SUN_STAR_UI_DIALOGS_EXTENDEDFILEPICKERELEMENTIDS_HPP_
#include <com/sun/star/ui/dialogs/ExtendedFilePickerElementIds.hpp>
#endif
#ifndef _COM_SUN_STAR_UI_DIALOGS_COMMONFILEPICKERELEMENTIDS_HPP_
#include <com/sun/star/ui/dialogs/CommonFilePickerElementIds.hpp>
#endif
#ifndef _COM_SUN_STAR_UI_DIALOGS_CONTROLACTIONS_HPP_
#include <com/sun/star/ui/dialogs/ControlActions.hpp>
#endif
#ifndef _COM_SUN_STAR_DOCUMENT_MACROEXECMODE_HPP_
#include <com/sun/star/document/MacroExecMode.hpp>
#endif
#ifndef _COM_SUN_STAR_DOCUMENT_UPDATEDOCMODE_HPP_
#include <com/sun/star/document/UpdateDocMode.hpp>
#endif
#ifndef _FILEDLGHELPER_HXX
#include <filedlghelper.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX
#include "fcontnr.hxx"
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <comphelper/processfactory.hxx>
#endif
#ifndef _CPPUHELPER_COMPBASE1_HXX_
#include <cppuhelper/compbase1.hxx>
#endif
#include "dispatch.hxx"
#include <comphelper/extract.hxx>
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::frame;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::io;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::util;
using namespace ::com::sun::star::ui::dialogs;
using namespace ::vos;
using namespace ::rtl;
using namespace sfx2;

//STRIP001 class SfxNotificationListener_Impl : public cppu::WeakImplHelper1< XDispatchResultListener >
//STRIP001 {
//STRIP001 public:
//STRIP001     virtual void SAL_CALL dispatchFinished( const DispatchResultEvent& aEvent ) throw( RuntimeException );
//STRIP001     virtual void SAL_CALL disposing( const EventObject& aEvent ) throw( RuntimeException );
//STRIP001 };

//STRIP001 void SAL_CALL SfxNotificationListener_Impl::dispatchFinished( const DispatchResultEvent& aEvent ) throw( RuntimeException )
//STRIP001 {
//STRIP001 #ifdef WNT
//STRIP001 	ShutdownIcon::LeaveModalMode();
//STRIP001 #endif
//STRIP001 }

//STRIP001 void SAL_CALL SfxNotificationListener_Impl::disposing( const EventObject& aEvent ) throw( RuntimeException )
//STRIP001 {
//STRIP001 }

/*N*/ SFX_IMPL_XSERVICEINFO( ShutdownIcon, "com.sun.star.office.Quickstart", "com.sun.star.comp.desktop.QuickstartWrapper" )	\
/*N*/ SFX_IMPL_ONEINSTANCEFACTORY( ShutdownIcon );

ShutdownIcon* ShutdownIcon::pShutdownIcon = 0;

/*?*/ ShutdownIcon::ShutdownIcon( Reference< XMultiServiceFactory > aSMgr ) :
/*?*/ 	ShutdownIconServiceBase( m_aMutex ),
/*?*/ 	m_xServiceManager( aSMgr ),
/*?*/ 	m_pResMgr( 0 ),
/*?*/ 	m_bVeto ( false )
/*?*/ {
/*?*/ }

/*?*/ ShutdownIcon::~ShutdownIcon()
/*?*/ {DBG_BF_ASSERT(0, "STRIP");//STRIP001 
/*?*/ #ifdef WNT
//STRIP001 /*?*/     deInitSystray();
/*?*/ #endif
/*?*/ }

// ---------------------------------------------------------------------------

//STRIP001 void ShutdownIcon::SetAutostart( bool bActivate )
//STRIP001 {
//STRIP001 #ifdef WNT
//STRIP001     OUString aShortcutName( RTL_CONSTASCII_USTRINGPARAM( "StarOffice 6.0" ) );
//STRIP001     if( SFX_APP() && SFX_APP()->GetSfxResManager() )
//STRIP001     {
//STRIP001         ::vos::OGuard aGuard( Application::GetSolarMutex() );
//STRIP001         UniString aRes( ResId( STR_QUICKSTART_LNKNAME, SFX_APP()->GetSfxResManager() ) );
//STRIP001         aShortcutName = OUString( aRes );
//STRIP001     }
//STRIP001     aShortcutName += OUString( RTL_CONSTASCII_USTRINGPARAM( ".lnk" ) );
//STRIP001 
//STRIP001     SetAutostartW32( aShortcutName, bActivate );
//STRIP001 #endif
//STRIP001 }

/*?*/ bool ShutdownIcon::GetAutostart( )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); return false;//STRIP001 
//STRIP001 #ifdef WNT
//STRIP001     OUString aShortcutName( RTL_CONSTASCII_USTRINGPARAM( "StarOffice 6.0" ) );
//STRIP001     if( SFX_APP() && SFX_APP()->GetSfxResManager() )
//STRIP001     {
//STRIP001         ::vos::OGuard aGuard( Application::GetSolarMutex() );
//STRIP001         UniString aRes( ResId( STR_QUICKSTART_LNKNAME, SFX_APP()->GetSfxResManager() ) );
//STRIP001         aShortcutName = OUString( aRes );
//STRIP001     }
//STRIP001     aShortcutName += OUString( RTL_CONSTASCII_USTRINGPARAM( ".lnk" ) );
//STRIP001 
//STRIP001     return GetAutostartW32( aShortcutName );
//STRIP001 #else
//STRIP001     return false;
//STRIP001 #endif
/*?*/ }


// ---------------------------------------------------------------------------

//STRIP001 void ShutdownIcon::OpenURL( const ::rtl::OUString& aURL, const ::rtl::OUString& rTarget, const Sequence< PropertyValue >& aArgs )
//STRIP001 {
//STRIP001     if ( getInstance() && getInstance()->m_xDesktop.is() )
//STRIP001     {
//STRIP001         Reference < XComponentLoader > xLoader ( getInstance()->m_xDesktop, UNO_QUERY );
//STRIP001         if( xLoader.is() )
//STRIP001         {
//STRIP001             try
//STRIP001             {
//STRIP001                 xLoader->loadComponentFromURL(
//STRIP001                     aURL,
//STRIP001                     rTarget,
//STRIP001                     0,
//STRIP001                     aArgs );
//STRIP001             }
//STRIP001             catch( IOException )
//STRIP001             {
//STRIP001                 OSL_ENSURE( 0, "IOException in loadComponentFromURL!");
//STRIP001             }
//STRIP001             catch( IllegalArgumentException )
//STRIP001             {
//STRIP001                 OSL_ENSURE( 0, "IllegalArgumentException in loadComponentFromURL!");
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001 }

// ---------------------------------------------------------------------------

//STRIP001 void ShutdownIcon::FileOpen()
//STRIP001 {
//STRIP001     if ( getInstance() && getInstance()->m_xDesktop.is() )
//STRIP001     {
//STRIP001         ::vos::OGuard aGuard( Application::GetSolarMutex() );
//STRIP001 #ifdef WNT
//STRIP001 		EnterModalMode();
//STRIP001 #endif
//STRIP001 		// use ctor for filling up filters automatically! #89169#
//STRIP001 		FileDialogHelper dlg( WB_OPEN | SFXWB_MULTISELECTION, *(SfxObjectFactory*) NULL );
//STRIP001         if ( ERRCODE_NONE == dlg.Execute() )
//STRIP001 		{
//STRIP001 			Reference< XFilePicker >	xPicker = dlg.GetFilePicker();
//STRIP001 
//STRIP001 			try
//STRIP001 			{
//STRIP001 
//STRIP001 				if ( xPicker.is() )
//STRIP001 				{
//STRIP001 
//STRIP001 					Reference < XFilePickerControlAccess > xPickerControls ( xPicker, UNO_QUERY );
//STRIP001 					Reference < XFilterManager > xFilterManager ( xPicker, UNO_QUERY );
//STRIP001 
//STRIP001 					Sequence< OUString >		sFiles = xPicker->getFiles();
//STRIP001 					int							nFiles = sFiles.getLength();
//STRIP001 
//STRIP001                     int                         nArgs=3;
//STRIP001                     Sequence< PropertyValue >   aArgs(3);
//STRIP001 
//STRIP001                     Reference < ::com::sun::star::task::XInteractionHandler > xInteraction(
//STRIP001                         ::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance( OUString::createFromAscii("com.sun.star.task.InteractionHandler") ),
//STRIP001                         ::com::sun::star::uno::UNO_QUERY );
//STRIP001 
//STRIP001                     aArgs[0].Name = OUString::createFromAscii( "InteractionHandler" );
//STRIP001                     aArgs[0].Value <<= xInteraction;
//STRIP001 
//STRIP001 					sal_Int16 nMacroExecMode = ::com::sun::star::document::MacroExecMode::USE_CONFIG;
//STRIP001                     aArgs[1].Name = OUString::createFromAscii( "MacroExecutionMode" );
//STRIP001                     aArgs[1].Value <<= nMacroExecMode;
//STRIP001 
//STRIP001 					sal_Int16 nUpdateDoc = ::com::sun::star::document::UpdateDocMode::ACCORDING_TO_CONFIG;
//STRIP001                     aArgs[2].Name = OUString::createFromAscii( "UpdateDocMode" );
//STRIP001                     aArgs[2].Value <<= nUpdateDoc;
//STRIP001 
//STRIP001 					// pb: #102643# use the filedlghelper to get the current filter name,
//STRIP001 					// because it removes the extensions before you get the filter name.
//STRIP001 					OUString aFilterName( dlg.GetCurrentFilter() );
//STRIP001 
//STRIP001 					if ( xPickerControls.is() )
//STRIP001 					{
//STRIP001 
//STRIP001 						// Set readonly flag
//STRIP001 
//STRIP001 						sal_Bool	bReadOnly = sal_False;
//STRIP001 
//STRIP001 
//STRIP001 						xPickerControls->getValue( ExtendedFilePickerElementIds::CHECKBOX_READONLY, 0 ) >>= bReadOnly;
//STRIP001 
//STRIP001 						// #95239#: Only set porperty if readonly is set to TRUE
//STRIP001 
//STRIP001 						if ( bReadOnly )
//STRIP001 						{
//STRIP001 							aArgs.realloc( ++nArgs );
//STRIP001 							aArgs[nArgs-1].Name  = OUString::createFromAscii( "ReadOnly" );
//STRIP001 							aArgs[nArgs-1].Value <<= bReadOnly;
//STRIP001 						}
//STRIP001 
//STRIP001 						// Get version string
//STRIP001 
//STRIP001 						sal_Int32	iVersion = -1;
//STRIP001 
//STRIP001 						xPickerControls->getValue( ExtendedFilePickerElementIds::LISTBOX_VERSION, ControlActions::GET_SELECTED_ITEM_INDEX ) >>= iVersion;
//STRIP001 
//STRIP001 						if ( iVersion >= 0 )
//STRIP001 						{
//STRIP001 							sal_Int16	uVersion = (sal_Int16)iVersion;
//STRIP001 
//STRIP001 							aArgs.realloc( ++nArgs );
//STRIP001 							aArgs[nArgs-1].Name  = OUString::createFromAscii( "Version" );
//STRIP001 							aArgs[nArgs-1].Value <<= uVersion;
//STRIP001 						}
//STRIP001 
//STRIP001 						// Retrieve the current filter
//STRIP001 
//STRIP001 						if ( !aFilterName.getLength() )
//STRIP001 							xPickerControls->getValue( CommonFilePickerElementIds::LISTBOX_FILTER, ControlActions::GET_SELECTED_ITEM ) >>= aFilterName;
//STRIP001 
//STRIP001 					}
//STRIP001 
//STRIP001 
//STRIP001 					// Convert UI filter name to internal filter name
//STRIP001 
//STRIP001 					if ( aFilterName.getLength() )
//STRIP001 					{
//STRIP001 						const SfxFilter* pFilter = SFX_APP()->GetFilterMatcher().GetFilter4UIName( aFilterName, 0, SFX_FILTER_NOTINFILEDLG );
//STRIP001 
//STRIP001 						if ( pFilter )
//STRIP001 						{
//STRIP001                             aFilterName = pFilter->GetFilterName();
//STRIP001 
//STRIP001 							if ( aFilterName.getLength() )
//STRIP001 							{
//STRIP001 								aArgs.realloc( ++nArgs );
//STRIP001 								aArgs[nArgs-1].Name  = OUString::createFromAscii( "FilterName" );
//STRIP001 								aArgs[nArgs-1].Value <<= aFilterName;
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 
//STRIP001 					if ( 1 == nFiles )
//STRIP001                         OpenURL( sFiles[0], OUString( RTL_CONSTASCII_USTRINGPARAM( "_default" ) ), aArgs );
//STRIP001 					else
//STRIP001 					{
//STRIP001 						OUString	aBaseDirURL = sFiles[0];
//STRIP001 						if ( aBaseDirURL.getLength() > 0 && aBaseDirURL[aBaseDirURL.getLength()-1] != '/' )
//STRIP001 							aBaseDirURL += OUString::createFromAscii("/");
//STRIP001 
//STRIP001 						int	iFiles;
//STRIP001 						for ( iFiles = 1; iFiles < nFiles; iFiles++ )
//STRIP001 						{
//STRIP001 							OUString	aURL = aBaseDirURL;
//STRIP001 							aURL += sFiles[iFiles];
//STRIP001                             OpenURL( aURL, OUString( RTL_CONSTASCII_USTRINGPARAM( "_default" ) ), aArgs );
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			catch ( ... )
//STRIP001 			{
//STRIP001 			}
//STRIP001 		}
//STRIP001 #ifdef WNT
//STRIP001 		LeaveModalMode();
//STRIP001 #endif
//STRIP001     }
//STRIP001 }

// ---------------------------------------------------------------------------

//STRIP001 void ShutdownIcon::FromTemplate()
//STRIP001 {
//STRIP001     if ( getInstance() && getInstance()->m_xDesktop.is() )
//STRIP001     {
//STRIP001         Reference < ::com::sun::star::frame::XFramesSupplier > xDesktop ( getInstance()->m_xDesktop, UNO_QUERY);
//STRIP001         Reference < ::com::sun::star::frame::XFrame > xFrame( xDesktop->getActiveFrame() );
//STRIP001         if ( !xFrame.is() )
//STRIP001             xFrame = Reference < ::com::sun::star::frame::XFrame >( xDesktop, UNO_QUERY );
//STRIP001 
//STRIP001         URL aTargetURL;
//STRIP001         aTargetURL.Complete = OUString( RTL_CONSTASCII_USTRINGPARAM( "slot:5500" ) );
//STRIP001         Reference < XURLTransformer > xTrans( ::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance( ::rtl::OUString::createFromAscii("com.sun.star.util.URLTransformer" )), UNO_QUERY );
//STRIP001         xTrans->parseStrict( aTargetURL );
//STRIP001 
//STRIP001         Reference < ::com::sun::star::frame::XDispatchProvider > xProv( xFrame, UNO_QUERY );
//STRIP001         Reference < ::com::sun::star::frame::XDispatch > xDisp;
//STRIP001 	    if ( xProv.is() )
//STRIP001             if ( aTargetURL.Protocol.compareToAscii("slot:") == COMPARE_EQUAL )
//STRIP001                 xDisp = xProv->queryDispatch( aTargetURL, ::rtl::OUString(), 0 );
//STRIP001             else
//STRIP001                 xDisp = xProv->queryDispatch( aTargetURL, ::rtl::OUString::createFromAscii("_blank"), 0 );
//STRIP001         if ( xDisp.is() )
//STRIP001 	    {
//STRIP001 		    Sequence<PropertyValue> aArgs(1);
//STRIP001 		    PropertyValue* pArg = aArgs.getArray();
//STRIP001 		    pArg[0].Name = ::rtl::OUString::createFromAscii("Referer");
//STRIP001             pArg[0].Value <<= ::rtl::OUString::createFromAscii("private:user");
//STRIP001             Reference< ::com::sun::star::frame::XNotifyingDispatch > xNotifyer( xDisp, UNO_QUERY );
//STRIP001             if ( xNotifyer.is() )
//STRIP001 			{
//STRIP001 #ifdef WNT
//STRIP001 				EnterModalMode();
//STRIP001 #endif
//STRIP001                 xNotifyer->dispatchWithNotification( aTargetURL, aArgs, new SfxNotificationListener_Impl() );
//STRIP001 			}
//STRIP001             else
//STRIP001                 xDisp->dispatch( aTargetURL, aArgs );
//STRIP001 	    }
//STRIP001     }
//STRIP001 }

// ---------------------------------------------------------------------------

//STRIP001 OUString ShutdownIcon::GetResString( int id )
//STRIP001 {
//STRIP001     ::vos::OGuard aGuard( Application::GetSolarMutex() );
//STRIP001 
//STRIP001     if( !m_pResMgr )
//STRIP001         return OUString();
//STRIP001 
//STRIP001     UniString aRes( ResId(id, m_pResMgr) );
//STRIP001     return OUString( aRes );
//STRIP001 }

// ---------------------------------------------------------------------------

//STRIP001 OUString ShutdownIcon::GetUrlDescription( const OUString& aUrl )
//STRIP001 {
//STRIP001     ::vos::OGuard aGuard( Application::GetSolarMutex() );
//STRIP001 
//STRIP001     return OUString( SvFileInformationManager::GetDescription( INetURLObject( aUrl ) ) );
//STRIP001 }

// ---------------------------------------------------------------------------

//STRIP001 void ShutdownIcon::addTerminateListener()
//STRIP001 {
//STRIP001 	if ( getInstance() && getInstance()->m_xDesktop.is() )
//STRIP001 		getInstance()->m_xDesktop->addTerminateListener( getInstance() );
//STRIP001 }

// ---------------------------------------------------------------------------

//STRIP001 void ShutdownIcon::terminateDesktop()
//STRIP001 {
//STRIP001     if ( getInstance() && getInstance()->m_xDesktop.is() )
//STRIP001     {
//STRIP001         // always remove ourselves as listener
//STRIP001         getInstance()->m_xDesktop->removeTerminateListener( getInstance() );
//STRIP001 
//STRIP001         // terminate desktop only if no tasks exist
//STRIP001         Reference < XFramesSupplier > xSupplier( getInstance()->m_xDesktop, UNO_QUERY );
//STRIP001         if( xSupplier.is() )
//STRIP001         {
//STRIP001             Reference < XIndexAccess > xTasks ( xSupplier->getFrames(), UNO_QUERY );
//STRIP001             if( xTasks.is() )
//STRIP001             {
//STRIP001                 if( xTasks->getCount()<1 )
//STRIP001                     getInstance()->m_xDesktop->terminate();
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001 }

// ---------------------------------------------------------------------------

//STRIP001 ShutdownIcon* ShutdownIcon::getInstance()
//STRIP001 {
//STRIP001 	OSL_ASSERT( pShutdownIcon );
//STRIP001 	return pShutdownIcon;
//STRIP001 }

// ---------------------------------------------------------------------------

/*N*/ void SAL_CALL ShutdownIcon::disposing()
/*N*/ {
/*N*/ 	m_xServiceManager = Reference< XMultiServiceFactory >();
/*N*/ 	m_xDesktop = Reference< XDesktop >();
/*N*/ }

// ---------------------------------------------------------------------------

// XEventListener
/*?*/ void SAL_CALL ShutdownIcon::disposing( const ::com::sun::star::lang::EventObject& Source )
/*?*/ 	throw(::com::sun::star::uno::RuntimeException)
/*?*/ {
/*?*/ }

// ---------------------------------------------------------------------------

// XTerminateListener
/*?*/ void SAL_CALL ShutdownIcon::queryTermination( const ::com::sun::star::lang::EventObject& aEvent )
/*?*/ throw(::com::sun::star::frame::TerminationVetoException, ::com::sun::star::uno::RuntimeException)
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	::osl::ClearableMutexGuard	aGuard(	m_aMutex );
//STRIP001 
//STRIP001 	if ( m_bVeto )
//STRIP001 		throw ::com::sun::star::frame::TerminationVetoException();
/*?*/ }


// ---------------------------------------------------------------------------

/*?*/ void SAL_CALL ShutdownIcon::notifyTermination( const ::com::sun::star::lang::EventObject& aEvent )
/*?*/ throw(::com::sun::star::uno::RuntimeException)
/*?*/ {
/*?*/ }


// ---------------------------------------------------------------------------

/*N*/ void SAL_CALL ShutdownIcon::initialize( const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any>& aArguments )
/*N*/ 	throw( ::com::sun::star::uno::Exception )
/*N*/ {
/*N*/ 	::osl::ClearableMutexGuard	aGuard(	m_aMutex );
/*N*/ 
/*N*/ 	if ( aArguments.getLength() > 0 )
/*N*/ 	{
/*N*/ 		if ( !ShutdownIcon::pShutdownIcon )
/*N*/ 		{
/*N*/ 			try
/*N*/ 			{
/*N*/ 				sal_Bool bQuickstart = sal_False;
/*N*/ 				bQuickstart = ::cppu::any2bool( aArguments[0] );
/*N*/ 				if( !bQuickstart && !GetAutostart() )
/*N*/ 					return;
/*N*/				DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 /*?*/ 				m_pResMgr = SFX_APP()->GetSfxResManager();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				m_xDesktop = Reference < XDesktop >( m_xServiceManager->createInstance(
//STRIP001 /*?*/ 															DEFINE_CONST_UNICODE( "com.sun.star.frame.Desktop" )),
//STRIP001 /*?*/ 														UNO_QUERY );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				if ( !m_xDesktop.is() )
//STRIP001 /*?*/ 					return;
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				ShutdownIcon::pShutdownIcon = this;
//STRIP001 /*?*/ #ifdef WNT
//STRIP001 /*?*/ 				initSystray();
//STRIP001 /*?*/ #endif
/*?*/ 			}
/*?*/ 			catch(const ::com::sun::star::lang::IllegalArgumentException&)
/*?*/ 			{
/*?*/ 			}
/*N*/ 		}
/*N*/ 	}
/*N*/ }
}
