/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svx_pfiledlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 05:00:01 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SFXDOCFILE_HXX
#include <bf_sfx2/docfile.hxx>
#endif

#ifndef _COM_SUN_STAR_PLUGIN_PLUGINDESCRIPTION_HPP_
#include <com/sun/star/plugin/PluginDescription.hpp>
#endif
#ifndef _COM_SUN_STAR_PLUGIN_XPLUGINMANAGER_HPP_
#include <com/sun/star/plugin/XPluginManager.hpp>
#endif

#include <comphelper/processfactory.hxx>

#include "pfiledlg.hxx"
#include "dialogs.hrc"

#include "dialmgr.hxx"
#include <list>

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {
 
using namespace ::rtl;
using namespace ::com::sun::star;

//STRIP001 sal_Char __READONLY_DATA sAudio[] = "audio";
//STRIP001 sal_Char __READONLY_DATA sVideo[] = "video";

/*************************************************************************
|*
|* Filedialog to insert Plugin-Fileformats
|*
\************************************************************************/

//STRIP001 ErrCode SvxPluginFileDlg::Execute()
//STRIP001 {
//STRIP001 	return maFileDlg.Execute();
//STRIP001 }

//STRIP001 String SvxPluginFileDlg::GetPath() const
//STRIP001 {
//STRIP001 	return maFileDlg.GetPath();
//STRIP001 }

//STRIP001 SvxPluginFileDlg::SvxPluginFileDlg (Window *pParent, sal_uInt16 nKind ) : 
//STRIP001 	maFileDlg(SFXWB_INSERT)
//STRIP001 {
//STRIP001 	// set title of the dialogwindow
//STRIP001 	switch (nKind)
//STRIP001 	{
//STRIP001 		case SID_INSERT_SOUND :
//STRIP001 		{
//STRIP001 			maFileDlg.SetTitle(SVX_RESSTR(STR_INSERT_SOUND_TITLE));
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case SID_INSERT_VIDEO :
//STRIP001 		{
//STRIP001 			maFileDlg.SetTitle(SVX_RESSTR(STR_INSERT_VIDEO_TITLE));
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	// fill the filterlist of the filedialog with data of installed plugins
//STRIP001 	uno::Reference< lang::XMultiServiceFactory >  xMgr( ::legacy_binfilters::getLegacyProcessServiceFactory() );
//STRIP001 
//STRIP001 	if( xMgr.is() )
//STRIP001 	{
//STRIP001 		uno::Reference< plugin::XPluginManager > rPluginManager( xMgr->createInstance(
//STRIP001 			OUString::createFromAscii( "com.sun.star.plugin.PluginManager" ) ), uno::UNO_QUERY );
//STRIP001 		if ( rPluginManager.is() )
//STRIP001 		{
//STRIP001 			const uno::Sequence<plugin::PluginDescription > aSeq( rPluginManager->getPluginDescriptions() );
//STRIP001 			const plugin::PluginDescription* pDescription = aSeq.getConstArray();
//STRIP001 			sal_Int32 nAnzahlPlugins = rPluginManager->getPluginDescriptions().getLength();
//STRIP001 
//STRIP001 			std::list< String >	aPlugNames;
//STRIP001 			std::list< String >	aPlugExtensions;
//STRIP001 			std::list< String >::iterator j;
//STRIP001 			std::list< String >::iterator k;
//STRIP001 			std::list< String >::const_iterator end;
//STRIP001 
//STRIP001 			for ( int i = 0; i < nAnzahlPlugins; i++ )
//STRIP001 			{
//STRIP001 				String aStrPlugMIMEType( pDescription[i].Mimetype );
//STRIP001 				String aStrPlugName( pDescription[i].Description );
//STRIP001 				String aStrPlugExtension( pDescription[i].Extension );
//STRIP001 
//STRIP001 				aStrPlugMIMEType.ToLowerAscii();
//STRIP001 				aStrPlugExtension.ToLowerAscii();
//STRIP001 
//STRIP001 				if ( ( nKind == SID_INSERT_SOUND && aStrPlugMIMEType.SearchAscii ( sAudio ) == 0 ) ||
//STRIP001 					 ( nKind == SID_INSERT_VIDEO && aStrPlugMIMEType.SearchAscii ( sVideo ) == 0 ) )
//STRIP001 				{
//STRIP001 					// extension already in the filterlist of the filedlg ?
//STRIP001 					sal_Bool bAlreadyExist = sal_False;
//STRIP001 					for ( j = aPlugExtensions.begin(), end = aPlugExtensions.end(); j != end && !bAlreadyExist; ++j )
//STRIP001 					{
//STRIP001 						bAlreadyExist = (j->Search( aStrPlugExtension ) != STRING_NOTFOUND );
//STRIP001 					}
//STRIP001 
//STRIP001 					if ( !bAlreadyExist )
//STRIP001 					{
//STRIP001 						// filterdescription already there?
//STRIP001 						// (then append the new extension to the existing filter)
//STRIP001 						int nfound = -1;						
//STRIP001  						for ( j = aPlugNames.begin(),
//STRIP001 								  k = aPlugExtensions.begin(),
//STRIP001 								  end = aPlugNames.end(); 
//STRIP001 							  j != end && nfound != 0;  )
//STRIP001 						{
//STRIP001 							if ( ( nfound = j->Search( aStrPlugName ) ) == 0 )
//STRIP001 							{
//STRIP001 								if ( aStrPlugExtension.Len() > 0 )
//STRIP001 									aStrPlugExtension.Insert( sal_Unicode( ';' ) );
//STRIP001 								aStrPlugExtension.Insert( *k );
//STRIP001 
//STRIP001 								// remove old entry, increment (iterators are invalid thereafter, thus the postincrement)
//STRIP001 								aPlugNames.erase(j++); aPlugExtensions.erase(k++);
//STRIP001 								
//STRIP001 								// update end iterator (which may be invalid, too!)
//STRIP001 								end = aPlugNames.end(); 
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								// next element
//STRIP001 								++j; ++k;
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 						// build filterdescription
//STRIP001 						aStrPlugName.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "  (" ) );
//STRIP001 						aStrPlugName.Append( aStrPlugExtension );
//STRIP001 						aStrPlugName.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ")" ) );
//STRIP001 
//STRIP001 						// use a own description for the video-formate avi, mov and mpeg
//STRIP001 						// the descriptions of these MIME-types are not very meaningful
//STRIP001 						const sal_Char sAVI[] = "*.avi";
//STRIP001 						const sal_Char sMOV[] = "*.mov";
//STRIP001 						const sal_Char sMPG[] = "*.mpg";
//STRIP001 						const sal_Char sMPE[] = "*.mpe";
//STRIP001 						const sal_Char sMPEG[] = "*.mpeg";
//STRIP001 
//STRIP001 						if ( aStrPlugExtension.EqualsIgnoreCaseAscii( sAVI ) )
//STRIP001 							aStrPlugName = SVX_RESSTR( STR_INSERT_VIDEO_EXTFILTER_AVI );
//STRIP001 						else if ( aStrPlugExtension.EqualsIgnoreCaseAscii( sMOV ) )
//STRIP001 							aStrPlugName = SVX_RESSTR( STR_INSERT_VIDEO_EXTFILTER_MOV );
//STRIP001 						else if ( aStrPlugExtension.SearchAscii( sMPG ) != STRING_NOTFOUND ||
//STRIP001 								  aStrPlugExtension.SearchAscii( sMPE ) != STRING_NOTFOUND ||
//STRIP001 								  aStrPlugExtension.SearchAscii( sMPEG ) != STRING_NOTFOUND )
//STRIP001 							aStrPlugName = SVX_RESSTR(STR_INSERT_VIDEO_EXTFILTER_MPEG);
//STRIP001 
//STRIP001 						aPlugNames.push_back( aStrPlugName );
//STRIP001 						aPlugExtensions.push_back( aStrPlugExtension );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			// add filter to dialog			
//STRIP001 			for ( j = aPlugNames.begin(), 
//STRIP001 					  k = aPlugExtensions.begin(),
//STRIP001 					  end = aPlugNames.end(); 
//STRIP001 				  j != end; ++j, ++k )
//STRIP001 			{
//STRIP001 				maFileDlg.AddFilter( *j, *k );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// add the All-Filter
//STRIP001     String aAllFilter( ResId( STR_EXTFILTER_ALL, DIALOG_MGR() ) );
//STRIP001 	maFileDlg.AddFilter( aAllFilter, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.*" ) ) );
//STRIP001 
//STRIP001 	// and activate him
//STRIP001 	maFileDlg.SetCurrentFilter( aAllFilter );
//STRIP001 }

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

//STRIP001 SvxPluginFileDlg::~SvxPluginFileDlg()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Plugins available for the the MIME-Typ in nKind
|* (whith nKind = SID_INSERT_SOUND for MIME-Type audio
|*                SID_INSERT_VIDEO for MIME-Type video
|*
\************************************************************************/

//STRIP001 #define PFDLG_CHECKED_SOUND		0x0001
//STRIP001 #define PFDLG_CHECKED_VIDEO		0x0002
//STRIP001 #define PFDLG_FOUND_SOUND		0x0004
//STRIP001 #define PFDLG_FOUND_VIDEO		0x0008

//STRIP001 sal_Bool SvxPluginFileDlg::IsAvailable (sal_uInt16 nKind)
//STRIP001 {
//STRIP001 	static sal_uInt16 nCheck = 0;
//STRIP001 
//STRIP001 	if ( nKind == SID_INSERT_SOUND && ( nCheck & PFDLG_CHECKED_SOUND ) )
//STRIP001 		return (nCheck & PFDLG_FOUND_SOUND);
//STRIP001 	if ( nKind == SID_INSERT_VIDEO && ( nCheck & PFDLG_CHECKED_VIDEO ) )
//STRIP001 		return (nCheck & PFDLG_FOUND_VIDEO);
//STRIP001 
//STRIP001 	sal_Bool bFound=sal_False;
//STRIP001 	uno::Reference< lang::XMultiServiceFactory >  xMgr( ::legacy_binfilters::getLegacyProcessServiceFactory() );
//STRIP001 
//STRIP001 	if( xMgr.is() )
//STRIP001 	{
//STRIP001 		uno::Reference< plugin::XPluginManager >  rPluginManager = uno::Reference< plugin::XPluginManager > ( xMgr->createInstance( OUString::createFromAscii( "com.sun.star.plugin.PluginManager" ) ), uno::UNO_QUERY );
//STRIP001 		if( rPluginManager.is() )
//STRIP001 		{
//STRIP001 			const uno::Sequence<plugin::PluginDescription > aSeq( rPluginManager->getPluginDescriptions() );
//STRIP001 			const plugin::PluginDescription* pDescription = aSeq.getConstArray();
//STRIP001 			sal_Int32 nAnzahlPlugins = rPluginManager->getPluginDescriptions().getLength();
//STRIP001 
//STRIP001 			for ( sal_uInt16 i = 0; i < nAnzahlPlugins && !bFound; ++i )
//STRIP001 			{
//STRIP001 				String aStrPlugMIMEType( pDescription[i].Mimetype );
//STRIP001 				switch (nKind)
//STRIP001 				{
//STRIP001 					case SID_INSERT_SOUND :
//STRIP001 					{
//STRIP001 						nCheck |= PFDLG_CHECKED_SOUND;
//STRIP001 
//STRIP001 						if( aStrPlugMIMEType.SearchAscii( sAudio ) == 0 )
//STRIP001 						{
//STRIP001 							bFound=sal_True;
//STRIP001 							nCheck |= PFDLG_FOUND_SOUND;
//STRIP001 						}
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_INSERT_VIDEO :
//STRIP001 					{
//STRIP001 						nCheck |= PFDLG_CHECKED_VIDEO;
//STRIP001 
//STRIP001 						if (aStrPlugMIMEType.SearchAscii( sVideo ) == 0)
//STRIP001 						{
//STRIP001 							bFound=sal_True;
//STRIP001 							nCheck |= PFDLG_FOUND_VIDEO;
//STRIP001 						}
//STRIP001 					}
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bFound;
//STRIP001 }

//STRIP001 void SvxPluginFileDlg::SetDialogHelpId( const sal_Int32 _nHelpId )
//STRIP001 {
//STRIP001 	maFileDlg.SetDialogHelpId( _nHelpId );
//STRIP001 }
//STRIP001 
//STRIP001 void SvxPluginFileDlg::SetContext( sfx2::FileDialogHelper::Context _eNewContext )
//STRIP001 {
//STRIP001 	maFileDlg.SetContext( _eNewContext );
//STRIP001 }
}
