/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: printopt.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 12:32:15 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SFX_PRINTOPT_HXX
#define _SFX_PRINTOPT_HXX

#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen wg. FixedText
#include <vcl/button.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen wg. FixedText
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_PRINT_HXX
#include <vcl/print.hxx>
#endif

// auto strip #include <bf_sfx2/tabdlg.hxx>
namespace binfilter {

// --------------------------------
// - SfxCommonPrintOptionsTabPage -
// --------------------------------

class SvtBasePrintOptions;

//STRIP001 class SfxCommonPrintOptionsTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001     FixedLine           aReduceGB;
//STRIP001 
//STRIP001     FixedText           aOutputTypeFT;
//STRIP001     RadioButton         aPrinterOutputRB;
//STRIP001     RadioButton         aPrintFileOutputRB;
//STRIP001 
//STRIP001     FixedLine           aOutputGB;
//STRIP001 
//STRIP001     CheckBox            aReduceTransparencyCB;
//STRIP001     RadioButton         aReduceTransparencyAutoRB;
//STRIP001     RadioButton         aReduceTransparencyNoneRB;
//STRIP001 
//STRIP001     CheckBox            aReduceGradientsCB;
//STRIP001     RadioButton         aReduceGradientsStripesRB;
//STRIP001     RadioButton         aReduceGradientsColorRB;
//STRIP001     NumericField        aReduceGradientsStepCountNF;
//STRIP001 
//STRIP001     CheckBox            aReduceBitmapsCB;
//STRIP001     RadioButton         aReduceBitmapsOptimalRB;
//STRIP001     RadioButton         aReduceBitmapsNormalRB;
//STRIP001     RadioButton         aReduceBitmapsResolutionRB;
//STRIP001     ListBox             aReduceBitmapsResolutionLB;
//STRIP001     CheckBox            aReduceBitmapsTransparencyCB;
//STRIP001 
//STRIP001     CheckBox            aConvertToGreyscalesCB;
//STRIP001 
//STRIP001     FixedLine           aWarnGB;
//STRIP001 
//STRIP001     CheckBox			aPaperSizeCB;
//STRIP001 	CheckBox			aPaperOrientationCB;
//STRIP001 	CheckBox			aTransparencyCB;
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001     PrinterOptions      maPrinterOptions;
//STRIP001     PrinterOptions      maPrintFileOptions;
//STRIP001 
//STRIP001                         DECL_LINK( ToggleOutputPrinterRBHdl, RadioButton* pButton );
//STRIP001                         DECL_LINK( ToggleOutputPrintFileRBHdl, RadioButton* pButton );
//STRIP001 
//STRIP001                         DECL_LINK( ClickReduceTransparencyCBHdl, CheckBox* pBox );
//STRIP001                         DECL_LINK( ClickReduceGradientsCBHdl, CheckBox* pBox );
//STRIP001                         DECL_LINK( ClickReduceBitmapsCBHdl, CheckBox* pBox );
//STRIP001 
//STRIP001                         DECL_LINK( ToggleReduceGradientsStripesRBHdl, RadioButton* pButton );
//STRIP001                         DECL_LINK( ToggleReduceBitmapsResolutionRBHdl, RadioButton* pButton );
//STRIP001 
//STRIP001     void                ImplUpdateControls( const PrinterOptions* pCurrentOptions );
//STRIP001     void                ImplSaveControls( PrinterOptions* pCurrentOptions );
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001     virtual int         DeactivatePage( SfxItemSet* pSet = NULL );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001                         SfxCommonPrintOptionsTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	                    ~SfxCommonPrintOptionsTabPage();
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 	virtual Window*		GetParentLabeledBy( const Window* pLabel ) const;
//STRIP001 	virtual Window*		GetParentLabelFor( const Window* pLabel ) const;
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 };

// -------------------------------
// - TransparencyPrintWarningBox -
// -------------------------------

//STRIP001 class TransparencyPrintWarningBox : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	FixedImage		aWarnFI;
//STRIP001 	FixedText		aWarnFT;
//STRIP001 	OKButton		aYesBtn;
//STRIP001 	PushButton	    aNoBtn;
//STRIP001     CancelButton    aCancelBtn;
//STRIP001 	CheckBox		aNoWarnCB;
//STRIP001 
//STRIP001                     DECL_LINK( ClickNoBtn, PushButton* );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 					TransparencyPrintWarningBox( Window* pParent );
//STRIP001 					~TransparencyPrintWarningBox();
//STRIP001 
//STRIP001 	BOOL			IsNoWarningChecked() const { return aNoWarnCB.IsChecked(); }
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SFX_PRINTOPT_HXX

