/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: colrctrl.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:10:45 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_COLRCTRL_HXX
#define _SVX_COLRCTRL_HXX

#ifndef _SFXDOCKWIN_HXX //autogen
#include <bf_sfx2/dockwin.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX //autogen
#include <bf_sfx2/childwin.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
#ifndef _TRANSFER_HXX //autogen
#include <svtools/transfer.hxx>
#endif
#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif
namespace binfilter {

class XColorTable;
class SvData;

/*************************************************************************
|*
|* SvxColorValueSet
|*
\************************************************************************/

//STRIP001 class SvxColorValueSet : public ValueSet, public DragSourceHelper
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	BOOL			bLeft;
//STRIP001 	Point           aDragPosPixel;
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	void            DoDrag();
//STRIP001 
//STRIP001 	// ValueSet
//STRIP001 	virtual void	MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void	MouseButtonUp( const MouseEvent& rMEvt );
//STRIP001 	virtual void    Command(const CommandEvent& rCEvt );
//STRIP001 
//STRIP001 	// DragSourceHelper
//STRIP001 	virtual void	StartDrag( sal_Int8 nAction, const Point& rPtPixel );
//STRIP001 
//STRIP001 					DECL_STATIC_LINK(SvxColorValueSet, ExecDragHdl, void*);
//STRIP001 
//STRIP001 public:
//STRIP001 					SvxColorValueSet( Window* pParent, WinBits nWinStyle = WB_ITEMBORDER );
//STRIP001 					SvxColorValueSet( Window* pParent, const ResId& rResId );
//STRIP001 
//STRIP001 	BOOL			IsLeftButton() const { return bLeft; }
//STRIP001 };

/*************************************************************************
|*
|* Ableitung vom SfxChildWindow als "Behaelter" fuer Controller
|*
\************************************************************************/

class SvxColorChildWindow : public SfxChildWindow
{
 public:
	SvxColorChildWindow( Window*, USHORT, SfxBindings*,
						 SfxChildWinInfo* );

	SFX_DECL_CHILDWINDOW(SvxColorChildWindow);
};

/*************************************************************************
|*
|* SvxColorDockingWindow
|*
\************************************************************************/

//STRIP001 class SvxColorDockingWindow : public SfxDockingWindow, public SfxListener
//STRIP001 {
//STRIP001  friend class SvxColorChildWindow;
//STRIP001 
//STRIP001 private:
//STRIP001 	XColorTable*		pColorTable;
//STRIP001 	SvxColorValueSet	aColorSet;
//STRIP001 	USHORT				nLeftSlot;
//STRIP001 	USHORT				nRightSlot;
//STRIP001 	USHORT				nCols;
//STRIP001 	USHORT				nLines;
//STRIP001 	long				nCount;
//STRIP001 	Size				aColorSize;
//STRIP001 	Size				aItemSize;
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	void				FillValueSet();
//STRIP001 	void 				SetSize();
//STRIP001 						DECL_LINK( SelectHdl, void * );
//STRIP001 
//STRIP001     /** This function is called when the window gets the focus.  It grabs
//STRIP001         the focus to the color value set so that it can be controlled with
//STRIP001         the keyboard.
//STRIP001     */
//STRIP001 	virtual void GetFocus (void);
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual BOOL	Close();
//STRIP001 	virtual void	Resize();
//STRIP001 	virtual void	Resizing( Size& rSize );
//STRIP001 
//STRIP001 
//STRIP001 public:
//STRIP001 					SvxColorDockingWindow( SfxBindings* pBindings,
//STRIP001 										   SfxChildWindow *pCW,
//STRIP001 										   Window* pParent,
//STRIP001 										   const ResId& rResId );
//STRIP001 					~SvxColorDockingWindow();
//STRIP001 
//STRIP001 	virtual void 	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
//STRIP001 							const SfxHint& rHint, const TypeId& rHintType );
//STRIP001 
//STRIP001 	void			SetSlotIDs( USHORT nLeft, USHORT nRight )
//STRIP001 						{ nLeftSlot = nLeft; nRightSlot = nRight; }
//STRIP001 
//STRIP001 	virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001 };

}//end of namespace binfilter
#endif

