/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: srchdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 14:30:24 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_SRCHDLG_HXX
#define _SVX_SRCHDLG_HXX

// include ---------------------------------------------------------------

#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX //autogen
#include <bf_sfx2/childwin.hxx>
#endif
#ifndef _BASEDLGS_HXX
#include <bf_sfx2/basedlgs.hxx>
#endif
#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif
#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

#ifndef _SFX_SRCHDEFS_HXX_
#include <bf_sfx2/srchdefs.hxx>
#endif
namespace binfilter {

// forward ---------------------------------------------------------------

//STRIP001 class SvxSearchItem;
//STRIP001 class MoreButton;
//STRIP001 class SfxStyleSheetBasePool;
//STRIP001 class SvxJSearchOptionsPage;

//STRIP001 struct SearchDlg_Impl;

#ifndef NO_SVX_SEARCH

// struct SearchAttrItem -------------------------------------------------

//STRIP001 struct SearchAttrItem
//STRIP001 {
//STRIP001 	USHORT 			nSlot;
//STRIP001 	SfxPoolItem* 	pItem;
//STRIP001 };

// class SearchAttrItemList ----------------------------------------------

//STRIP001 SV_DECL_VARARR(SrchAttrItemList, SearchAttrItem, 8, 8)//STRIP008 ;

//STRIP001 class SearchAttrItemList : private SrchAttrItemList
//STRIP001 {
//STRIP001 public:
//STRIP001 	SearchAttrItemList() {}
//STRIP001 	SearchAttrItemList( const SearchAttrItemList& rList );
//STRIP001 	~SearchAttrItemList();
//STRIP001 
//STRIP001 	void            Put( const SfxItemSet& rSet );
//STRIP001 	SfxItemSet&     Get( SfxItemSet& rSet );
//STRIP001 	void            Clear();
//STRIP001 	USHORT          Count() const { return SrchAttrItemList::Count(); }
//STRIP001 	SearchAttrItem& operator[](USHORT nPos) const
//STRIP001 						{ return SrchAttrItemList::operator[]( nPos ); }
//STRIP001 	SearchAttrItem& GetObject( USHORT nPos ) const
//STRIP001 						{ return SrchAttrItemList::GetObject( nPos ); }
//STRIP001 
//STRIP001 	// der Pointer auf das Item wird nicht kopiert!!! (also nicht l"oschen)
//STRIP001 	void Insert( const SearchAttrItem& rItem )
//STRIP001 		{ SrchAttrItemList::Insert( rItem, SrchAttrItemList::Count() ); }
//STRIP001 	// l"oscht die Pointer auf die Items
//STRIP001 	void Remove( USHORT nPos, USHORT nLen = 1 );
//STRIP001 };

#ifndef SV_NODIALOG

// class SvxSearchDialogWrapper ------------------------------------------

class SvxSearchDialogWrapper : public SfxChildWindow
{
public:
	SvxSearchDialogWrapper( Window*pParent, USHORT nId,
							SfxBindings* pBindings, SfxChildWinInfo* pInfo );

	SFX_DECL_CHILDWINDOW(SvxSearchDialogWrapper);
};

// class SvxSearchDialog -------------------------------------------------

/*
	{k:\svx\prototyp\dialog\srchdlg.hxx}

	[Beschreibung]
	In diesem Modeless-Dialog werden die Attribute einer Suche eingestellt
	und damit eine Suche gestartet. Es sind mehrere Sucharten
	( Suchen, Alle suchen, Ersetzen, Alle ersetzen ) m"oglich.

	[Items]
	<SvxSearchItem><SID_ATTR_SEARCH>
*/

//STRIP001 class SvxSearchDialog : public SfxModelessDialog
//STRIP001 {
//STRIP001 friend class SvxSearchController;
//STRIP001 friend class SvxSearchDialogWrapper;
//STRIP001 friend class SvxJSearchOptionsDialog;
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxSearchDialog( Window* pParent, SfxBindings& rBind );
//STRIP001 	SvxSearchDialog( Window* pParent, SfxChildWindow* pChildWin, SfxBindings& rBind );
//STRIP001 	~SvxSearchDialog();
//STRIP001 
//STRIP001 	virtual BOOL    Close();
//STRIP001 
//STRIP001 	// Window
//STRIP001 	virtual void	Activate();
//STRIP001 
//STRIP001 	void            GetSearchItems( SfxItemSet& rSet );
//STRIP001 	void            GetReplaceItems( SfxItemSet& rSet );
//STRIP001 
//STRIP001 	const SearchAttrItemList*   GetSearchItemList() const
//STRIP001 									{ return pSearchList; }
//STRIP001 	const SearchAttrItemList*   GetReplaceItemList() const
//STRIP001 									{ return pReplaceList; }
//STRIP001 
//STRIP001 	inline BOOL 	HasSearchAttributes() const;
//STRIP001 	inline BOOL 	HasReplaceAttributes() const;
//STRIP001 
//STRIP001 	PushButton&     GetReplaceBtn() { return aReplaceBtn; }
//STRIP001 
//STRIP001 	INT32			GetTransliterationFlags() const;
//STRIP001 
//STRIP001 private:
//STRIP001 	FixedText       aSearchText;
//STRIP001 	ComboBox        aSearchLB;
//STRIP001 	ListBox         aSearchTmplLB;
//STRIP001 	FixedInfo       aSearchAttrText;
//STRIP001 #if SUPD < 641 || defined( GT_DEBUG )
//STRIP001 	MultiLineEdit 	aSearchFormatsED;
//STRIP001 #endif
//STRIP001 
//STRIP001 	FixedText       aReplaceText;
//STRIP001 	ComboBox        aReplaceLB;
//STRIP001 	ListBox         aReplaceTmplLB;
//STRIP001 	FixedInfo       aReplaceAttrText;
//STRIP001 #if SUPD < 641 || defined( GT_DEBUG )
//STRIP001 	MultiLineEdit 	aReplaceFormatsED;
//STRIP001 #endif
//STRIP001 
//STRIP001 	PushButton      aSearchAllBtn;
//STRIP001 	PushButton      aSearchBtn;
//STRIP001 	PushButton      aReplaceAllBtn;
//STRIP001 	PushButton      aReplaceBtn;
//STRIP001 	PushButton      aAttributeBtn;
//STRIP001 	CancelButton    aCloseBtn;
//STRIP001 	PushButton      aFormatBtn;
//STRIP001 	HelpButton      aHelpBtn;
//STRIP001 	PushButton      aNoFormatBtn;
//STRIP001 	MoreButton*     pMoreBtn;
//STRIP001 
//STRIP001 	CheckBox        aWordBtn;
//STRIP001 	CheckBox        aMatchCaseCB;
//STRIP001 	CheckBox        aBackwardsBtn;
//STRIP001 	CheckBox        aSelectionBtn;
//STRIP001 	CheckBox        aRegExpBtn;
//STRIP001 	CheckBox        aLayoutBtn;
//STRIP001 					// "Ahnlichkeitssuche
//STRIP001 	CheckBox        aSimilarityBox;
//STRIP001 	PushButton      aSimilarityBtn;
//STRIP001 	CheckBox		aJapMatchFullHalfWidthCB;
//STRIP001 	CheckBox		aJapOptionsCB;
//STRIP001 	PushButton      aJapOptionsBtn;
//STRIP001     FixedLine       aOptionsFL;
//STRIP001 
//STRIP001 					// nur f"ur Calc
//STRIP001 	RadioButton     aFormulasBtn;
//STRIP001 	RadioButton     aValuesBtn;
//STRIP001 	RadioButton     aNotesBtn;
//STRIP001     FixedLine       aSearchFL;
//STRIP001     FixedLine       aSearchVertFL;
//STRIP001 
//STRIP001 	RadioButton     aRowsBtn;
//STRIP001 	RadioButton     aColumnsBtn;
//STRIP001     FixedLine       aSearchDirFL;
//STRIP001     FixedLine       aSearchDirVertFL;
//STRIP001 
//STRIP001 	CheckBox        aAllTablesCB;
//STRIP001     FixedLine       aCalcExtrasFL;
//STRIP001 
//STRIP001 	SfxBindings&    rBindings;
//STRIP001 	BOOL            bWriter;
//STRIP001 	BOOL            bSearch;
//STRIP001 	BOOL            bFormat;
//STRIP001 	USHORT          nOptions;
//STRIP001 	FASTBOOL		bSet;
//STRIP001 	FASTBOOL		bReadOnly;
//STRIP001 	FASTBOOL		bConstruct;
//STRIP001 	ULONG			nModifyFlag;
//STRIP001 	String          aStylesStr;
//STRIP001 	String			aLayoutStr;
//STRIP001 	String			aCalcStr;
//STRIP001 
//STRIP001 	SvStringsDtor   aSearchStrings;
//STRIP001 	SvStringsDtor   aReplaceStrings;
//STRIP001 
//STRIP001 	SearchDlg_Impl*			pImpl;
//STRIP001 	SearchAttrItemList*     pSearchList;
//STRIP001 	SearchAttrItemList*     pReplaceList;
//STRIP001 	SvxSearchItem*          pSearchItem;
//STRIP001 
//STRIP001 	SvxSearchController*    pSearchController;
//STRIP001 	SvxSearchController*    pOptionsController;
//STRIP001 	SvxSearchController*    pFamilyController;
//STRIP001 	SvxSearchController*    pSearchSetController;
//STRIP001 	SvxSearchController*    pReplaceSetController;
//STRIP001 
//STRIP001 	INT32			nTransliterationFlags;
//STRIP001 
//STRIP001 #ifdef _SVX_SRCHDLG_CXX
//STRIP001 	DECL_LINK( ModifyHdl_Impl, ComboBox* pEdit );
//STRIP001 	DECL_LINK( FlagHdl_Impl, Button* pBtn );
//STRIP001 	DECL_LINK( CommandHdl_Impl, Button* pBtn );
//STRIP001 	DECL_LINK( TemplateHdl_Impl, Button* );
//STRIP001 	DECL_LINK( FocusHdl_Impl, Control* );
//STRIP001 	DECL_LINK( LoseFocusHdl_Impl, Control* );
//STRIP001 	DECL_LINK( FormatHdl_Impl, Button* );
//STRIP001 	DECL_LINK( NoFormatHdl_Impl, Button* );
//STRIP001 	DECL_LINK( AttributeHdl_Impl, Button* );
//STRIP001 	DECL_LINK( TimeoutHdl_Impl, Timer* );
//STRIP001 
//STRIP001 	void			Construct_Impl();
//STRIP001 	void            InitControls_Impl();
//STRIP001 	void            Init_Impl( int bHasItemSet );
//STRIP001 	void            InitAttrList_Impl( const SfxItemSet* pSSet,
//STRIP001 									   const SfxItemSet* pRSet );
//STRIP001 	void            Remember_Impl( const String &rStr,BOOL bSearch );
//STRIP001 	void            PaintAttrText_Impl();
//STRIP001 	String&         BuildAttrText_Impl( String& rStr, BOOL bSrchFlag ) const;
//STRIP001 
//STRIP001 	void            TemplatesChanged_Impl( SfxStyleSheetBasePool& rPool );
//STRIP001 	void            EnableControls_Impl( const USHORT nFlags );
//STRIP001 	void            EnableControl_Impl( Control* pCtrl );
//STRIP001 	void            SetItem_Impl( const SvxSearchItem* pItem );
//STRIP001 
//STRIP001 	void			SetModifyFlag_Impl( const Control* pCtrl );
//STRIP001 	void			SaveToModule_Impl();
//STRIP001 
//STRIP001 	void			ApplyTransliterationFlags_Impl( INT32 nSettings );
//STRIP001 #endif
//STRIP001 };

//STRIP001 inline BOOL SvxSearchDialog::HasSearchAttributes() const
//STRIP001 {
//STRIP001 	int bLen = aSearchAttrText.GetText().Len();
//STRIP001 	return ( aSearchAttrText.IsEnabled() && bLen );
//STRIP001 }

//STRIP001 inline BOOL SvxSearchDialog::HasReplaceAttributes() const
//STRIP001 {
//STRIP001 	int bLen = aReplaceAttrText.GetText().Len();
//STRIP001 	return ( aReplaceAttrText.IsEnabled() && bLen );
//STRIP001 }

//////////////////////////////////////////////////////////////////////

//STRIP001 class SvxJSearchOptionsDialog : public SfxSingleTabDialog
//STRIP001 {
//STRIP001 	INT32					nInitialTlFlags;
//STRIP001 	SvxJSearchOptionsPage  *pPage;
//STRIP001 
//STRIP001 	// disallow copy-constructor and assignment-operator for now
//STRIP001 	SvxJSearchOptionsDialog( const SvxJSearchOptionsDialog & );
//STRIP001 	SvxJSearchOptionsDialog & operator == ( const SvxJSearchOptionsDialog & );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxJSearchOptionsDialog( Window *pParent,
//STRIP001 							const SfxItemSet& rOptionsSet, USHORT nUniqueId,
//STRIP001 							INT32 nInitialFlags  );
//STRIP001 	virtual ~SvxJSearchOptionsDialog();
//STRIP001 
//STRIP001 	// Window
//STRIP001 	virtual void	Activate();
//STRIP001 
//STRIP001 	INT32			GetTransliterationFlags() const;
//STRIP001 	void 			SetTransliterationFlags( INT32 nSettings );
//STRIP001 };

//////////////////////////////////////////////////////////////////////

#endif  // SV_NODIALOG
#endif  // NO_SVX_SEARCH

}//end of namespace binfilter
#endif

